/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	kumoriv1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKukuVHosts implements KukuVHostInterface
type FakeKukuVHosts struct {
	Fake *FakeKumoriV1
	ns   string
}

var kukuvhostsResource = schema.GroupVersionResource{Group: "kumori.systems", Version: "v1", Resource: "kukuvhosts"}

var kukuvhostsKind = schema.GroupVersionKind{Group: "kumori.systems", Version: "v1", Kind: "KukuVHost"}

// Get takes name of the kukuVHost, and returns the corresponding kukuVHost object, and an error if there is any.
func (c *FakeKukuVHosts) Get(name string, options v1.GetOptions) (result *kumoriv1.KukuVHost, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(kukuvhostsResource, c.ns, name), &kumoriv1.KukuVHost{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuVHost), err
}

// List takes label and field selectors, and returns the list of KukuVHosts that match those selectors.
func (c *FakeKukuVHosts) List(opts v1.ListOptions) (result *kumoriv1.KukuVHostList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(kukuvhostsResource, kukuvhostsKind, c.ns, opts), &kumoriv1.KukuVHostList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &kumoriv1.KukuVHostList{ListMeta: obj.(*kumoriv1.KukuVHostList).ListMeta}
	for _, item := range obj.(*kumoriv1.KukuVHostList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested kukuVHosts.
func (c *FakeKukuVHosts) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(kukuvhostsResource, c.ns, opts))

}

// Create takes the representation of a kukuVHost and creates it.  Returns the server's representation of the kukuVHost, and an error, if there is any.
func (c *FakeKukuVHosts) Create(kukuVHost *kumoriv1.KukuVHost) (result *kumoriv1.KukuVHost, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(kukuvhostsResource, c.ns, kukuVHost), &kumoriv1.KukuVHost{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuVHost), err
}

// Update takes the representation of a kukuVHost and updates it. Returns the server's representation of the kukuVHost, and an error, if there is any.
func (c *FakeKukuVHosts) Update(kukuVHost *kumoriv1.KukuVHost) (result *kumoriv1.KukuVHost, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(kukuvhostsResource, c.ns, kukuVHost), &kumoriv1.KukuVHost{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuVHost), err
}

// Delete takes name of the kukuVHost and deletes it. Returns an error if one occurs.
func (c *FakeKukuVHosts) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(kukuvhostsResource, c.ns, name), &kumoriv1.KukuVHost{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKukuVHosts) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(kukuvhostsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &kumoriv1.KukuVHostList{})
	return err
}

// Patch applies the patch and returns the patched kukuVHost.
func (c *FakeKukuVHosts) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *kumoriv1.KukuVHost, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(kukuvhostsResource, c.ns, name, pt, data, subresources...), &kumoriv1.KukuVHost{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuVHost), err
}
